# Copyright 2023 Zurich Instruments AG
# SPDX-License-Identifier: Apache-2.0


# __init__.py of 'experiment_schedule' package - autogenerated, do not edit
from __future__ import annotations

from dataclasses import dataclass, field
from typing import Dict, List

#
# Enums
#

#
# Data Classes
#


@dataclass
class Event:
    id: int = None
    time: float = None
    event_type: str = None
    event_data: Dict = field(default_factory=dict)


@dataclass
class SectionStructure:
    structure: Dict = field(default_factory=dict)


@dataclass
class ExperimentSchedule:
    uid: str = None
    events: List[Event] = field(default_factory=list)
    section_structure: SectionStructure = None
    experiment_hash: str = None
    compiled_experiment_hash: str = None
